import numpy as np
import pandas as pd
from operator import itemgetter
import math
import warnings
warnings.filterwarnings('ignore')
import numpy as np
import seaborn as sns
import matplotlib.pyplot as plt

import os
os.environ["CUDA_VISIBLE_DEVICES"]="0"

# file_path_full_training_set = '../Restructure_data/train_data+_sort.csv'
file_path_full_training_set = '../Restructure_data/train_data+_ADASYN.csv'
# file_path_full_training_set = '../Feature_Selection/FS_Data/noise_data.csv'
file_path_test = '../Restructure_data/test_data+_sort.csv'

df=pd.read_csv(file_path_full_training_set)
test_df=pd.read_csv(file_path_test)

feature_sort=['protocol_type','service','flag','src_bytes','dst_bytes','same_srv_rate','diff_srv_rate','logged_in','dst_host_srv_count','dst_host_same_srv_rate','dst_host_srv_serror_rate',
'dst_host_diff_srv_rate','dst_host_serror_rate','srv_serror_rate','serror_rate','count','srv_count','dst_host_same_src_port_rate','dst_host_srv_diff_host_rate','dst_host_count','srv_diff_host_rate','dst_host_srv_rerror_rate',
'rerror_rate','srv_rerror_rate','dst_host_rerror_rate','duration','hot','num_compromised','wrong_fragment','num_root','num_access_files','num_file_creations','is_guest_login','num_failed_logins','su_attempted','root_shell',
'num_shells','urgent','land','is_host_login','num_outbound_cmds','attack_class']
X_train = pd.DataFrame()
for i in range(len(feature_sort)):
    X_train = X_train.append(df[feature_sort[i]])
X_train = pd.DataFrame(X_train.values.T, columns=X_train.index, index=X_train.columns)


drop_cols = X_train.loc[:,[i for i in list(X_train.columns) if i not in [
'protocol_type',
'service',
'flag',
'src_bytes',
'dst_bytes',
'same_srv_rate',
'diff_srv_rate',
'logged_in',
'dst_host_srv_count',
'dst_host_same_srv_rate',
'dst_host_srv_serror_rate',
'dst_host_diff_srv_rate',
'count',
'srv_count',
'dst_host_same_src_port_rate',
'dst_host_srv_diff_host_rate',
'dst_host_count',
'srv_diff_host_rate',
'dst_host_srv_rerror_rate',
'duration',
'hot',
'num_compromised',
'wrong_fragment',
'num_access_files',
'num_file_creations',
'is_guest_login',
'num_failed_logins',
'su_attempted',
'root_shell',
'num_shells',
'urgent',
'land',
'is_host_login',
'num_outbound_cmds',
'attack_class'
]]]

X_train.drop(drop_cols, axis=1, inplace=True)
train_data = X_train.copy()
train_data.to_csv('../Restructure_data/train_data+_ADASYN_12.csv',index=False)
# train_data.to_csv('./FS_Data/validation_0.7.csv',index=False)

drop_cols1 =test_df.loc[:,[i for i in list(test_df.columns) if i not in [
'protocol_type',
'service',
'flag',
'src_bytes',
'dst_bytes',
'same_srv_rate',
'diff_srv_rate',
'logged_in',
'dst_host_srv_count',
'dst_host_same_srv_rate',
'dst_host_srv_serror_rate',
'dst_host_diff_srv_rate',
# 'count',
# 'srv_count',
# 'dst_host_same_src_port_rate',
# 'dst_host_srv_diff_host_rate',
# 'dst_host_count',
# 'srv_diff_host_rate',
# 'dst_host_srv_rerror_rate',
# 'duration',
# 'hot',
# 'num_compromised',
# 'wrong_fragment',
# 'num_access_files',
# 'num_file_creations',
# 'is_guest_login',
# 'num_failed_logins',
# 'su_attempted',
# 'root_shell',
# 'num_shells',
# 'urgent',
# 'land',
# 'is_host_login',
# 'num_outbound_cmds',
'attack_class'
]]]

test_df.drop(drop_cols1, axis=1, inplace=True)
test_data = test_df.copy()
test_data.to_csv('../Restructure_data/test_data+_12.csv',index=False)